﻿var GISBar = {
	gisclass: null, 
	GISClass: function () {
		this.ishash = '0f14315098daad405ded9270d1500bcb';
		this.host = 'http://d6a5c954.services.gismeteo.ru';
		this.newshost = 'http://news.gismeteo.ru/export/gismeteo7.xml';	
		this.cid = 0;
		this.cities = [];
		this.news = [];
		this.dict = null;
		this.winobj = null;
		this.strbundle = null;
		this.searchPopup = null;
		this.frcPanel = null;
		this.UTCTime = null;
		this.frcTimeout = null;
		this.frcUpdateInterval = null;	
		this.showFrcPanelTimeout = null;	
		this.newsUpdateInterval = 60000*60;				
		this.newsCallBackFunction = null;		
		this.refresh_link = null;
		this.callbackfunction = null;
		this.popupSearch = null;
		this.isToolbarButtonClick = false;
		this.isFrc = true;
		this.isStartUp = true; 
		this.lastWndW = 0;
		this.searchTimeout = null;
		this.init();
	},
	GISClassCityData: function(id, name) {
		this.id = id;
		this.name = name;
	  this.forecasts = [];
	  this.fact = [];    		
	  this.timezone = null; // !!! в минутах 	
	  this.clock = null;
		this.lastBuildFrcData = 0;
	},
	GISClassNewsData: function(title, description, pict, link) {
		this.title = escape(title);
		this.description = escape(description);
		this.pict = pict;
		this.link = link;		
	}
}
	
GISBar.GISClass.prototype.init = function() {
	this.winobj = this.getGlobalObj();	
	this.strbundle = this.winobj.getElementById("stringbundle");
	this.dict = this.getDict();
	this.cities = this.getCitiesList();
	this.draw();
	this.reloadToolbarIcon();
	this.getNews();	
	clearInterval(this.frcTimeout);
	this.render();
	var parent = this;	
	this.frcTimeout = setInterval(function() {parent.render()}, 20000);
  this.searchPopup = this.winobj.getElementById('popupSearch');
  this.frcPanel = this.winobj.getElementById('frcPanel');
	this.refresh_link = this.winobj.getElementById('refresh_a');
	this.setStaticTranslate();	 	   
}

GISBar.GISClass.prototype.getGlobalObj = function() {
	var obj = document.getElementById("navigator-toolbox");
	if (obj) return window.document;
	else return window.opener.document;
}

GISBar.GISClass.prototype.getDict = function() {
	var lang = this.getStorage("GismeteoLang");
	if (!lang)  {
		lang = navigator.userLanguage? navigator.userLanguage : navigator.language;
		if (lang.indexOf('ru')>-1) lang = 'ru';
		if (lang.indexOf('en')>-1) lang = 'en';
		if (lang.indexOf('uk')>-1) lang = 'ua';
		if (lang.indexOf('lt')>-1) lang = 'lt';	
	}
	return dict[lang]?dict[lang]:dict['en'];
}

GISBar.GISClass.prototype.getCitiesList = function() {
	var cities = null;
	try {
		var cities = this.getStorage('GismeteoCitiesList')?
								 JSON.parse(this.getStorage('GismeteoCitiesList')):
								 (this.getStorage('cityId') && this.getStorage('cityName'))?
								 [new GISBar.GISClassCityData(this.getStorage('cityId'), this.getStorage('cityName'))]:
								 [new GISBar.GISClassCityData(this.dict.default_city_id, escape(this.dict.default_city_name))];
	}
	catch (err) {}
	if (!cities || cities.length==0){
		cities = [new GISBar.GISClassCityData(this.dict.default_city_id, this.dict.default_city_name)];
		this.setStorage('GismeteoCitiesList', JSON.stringify(cities));
	}
	return cities;						
}

GISBar.GISClass.prototype.setCitiesList = function(cities) {
	this.setStorage('GismeteoCitiesList', JSON.stringify(cities));							
}

GISBar.GISClass.prototype.render = function() {
	var parent = this;
	for (var i = 0; i<this.cities.length; i++) {	
		var num = i;
		if(this.checkFrcData(this.cities[num]) == true) {
		  this.redraw(num);
			this.resizeBar(this);
		}
		else this.getFrc(num);
	}	
}

GISBar.GISClass.prototype.getFrc = function(i, callback) {
	var num = i;
	var cityObj = this.cities[num];
	var fcallback = callback;  
	var parent = this; 		
	var req = new XMLHttpRequest();	
	req.onreadystatechange = function() {
	if (req.readyState == 4)
		if (req.status == 200) {
			if (req.responseXML) var xmlElement = req.responseXML.documentElement;
			if (xmlElement != 'undefined' && xmlElement) var locations = xmlElement.getElementsByTagName('location');	
			if (locations != 'undefined' && locations) {
				with(parent) {
					cityObj.name = escape(locations[0].getAttribute("name"));							
					cityObj.timezone = locations[0].getAttribute("tzone");
					cityObj.fact = parent.parseData(locations[0], 'fact'); 
					cityObj.forecasts = parent.parseData(locations[0], 'forecast');	
					cityObj.lastBuildFrcData = (new Date()).getTime();
					parent.lastBuildFrcData	 = cityObj.lastBuildFrcData;								
					parent.UTCTime = parent.getUTCTime(new Date(req.getResponseHeader('Date'))).getTime();
					parent.setStorage('UTCTime', parent.UTCTime);
					parent.redraw(num);
					parent.setCitiesList(parent.cities);
					if (fcallback) fcallback();														
					parent.resizeBar(parent);	
				}																
			}			
		}
	}
	var now = new Date();
	//jsdump(checkTime(now.getFullYear())+'-'+checkTime(now.getMonth()+1)+'-'+checkTime(now.getDate())+' '+checkTime(now.getHours())+':'+checkTime(now.getMinutes())+' '+this.host +'/inform-service/'+this.ishash+'/forecast/?city='+cityObj.id+'&lang='+this.dict.lang);				
	req.open("GET", this.host +'/inform-service/'+this.ishash+'/forecast/?city='+cityObj.id+'&lang='+this.dict.lang, true);
	req.send(null);							
	
	function checkTime(i) {
		if (i<10) i="0" + i;
		return i;
	}	
}

GISBar.GISClass.prototype.checkFrcData = function(tmpdata) {
	this.frcUpdateInterval = this.getStorage("GismeteoTimeOut")?this.getStorage("GismeteoTimeOut"):60000*60;
	var lastBuildData = tmpdata.lastBuildFrcData?tmpdata.lastBuildFrcData:0;
	if (new Date().getTime()-lastBuildData >= this.frcUpdateInterval) return false;
	if(tmpdata.forecasts.length==0) return false;			
	return true;
}

GISBar.GISClass.prototype.parseData = function(data, item) {
	var items = data.getElementsByTagName(item);
	var d = [];
	if (items && items.length>0)
		for (var i=0; i<items.length; i++) {												
			var f = items[i].getElementsByTagName("values");
			data = {
				tod: parseInt(items[i].getAttribute("tod"), 10),
		  	day: this.getDay(items[i].getAttribute("valid"))[2],
		 	 	month: this.getDay(items[i].getAttribute("valid"))[1],
		  	year: this.getDay(items[i].getAttribute("valid"))[0],
				t:f[0].getAttribute('t'),							
				hi:f[0].getAttribute('hi'),
				p:f[0].getAttribute('p'),
				cl:f[0].getAttribute('cl'),
				pt:f[0].getAttribute('pt'),
				pr:f[0].getAttribute('pr'),
				ts:f[0].getAttribute('ts'),	
				wd:f[0].getAttribute('wd'),
				ws:f[0].getAttribute('ws'),
				hum:f[0].getAttribute('hum'), 
				icon:f[0].getAttribute('icon')  		
			};
			d.push(data);		
		}
	return d;			
}

GISBar.GISClass.prototype.getUTCTime = function(value) {
	return new Date(value.getUTCFullYear(), value.getUTCMonth(), value.getUTCDate(), value.getUTCHours(), value.getUTCMinutes(), 0, 0);					
}

GISBar.GISClass.prototype.getDay = function(valid) {
	var date=valid.split('T')[0];
  var arr_date=date.split('-');
  return  arr_date;
}

GISBar.GISClass.prototype.draw = function() {
	if (this.getStorage('gismeteo_search.width')) this.setAttr('gismeteo_search', 'style', 'width:'+this.getStorage('gismeteo_search.width')+'px');					
	for (var i=0; i<5; i++) {
		if(this.cities[i] == undefined) {
			this.setAttr('toolbaritem'+i, 'style', 'display: none;');						
			this.setStorage('strCity'+i+'.width', 'null');
		}
		else {
			this.setAttr('toolbaritem'+i, 'style', 'display: block;');
			this.setAttr('strCity'+i, 'value', unescape(this.cities[i].name));
			this.setAttr('phenomena'+i, 'style', ''/*list-style-image: url("'+icon+'");*/);		
			this.setAttr('bartemper'+i, 'value', '');      							
			if (this.getStorage('strCity'+i+'.width')) 
				this.setAttr('strCity'+i, 'style', 'width:'+this.getStorage('strCity'+i+'.width')+'px');				
		}
	}
}


GISBar.GISClass.prototype.resizeBar = function(parent) {
	var spacer = parent.winobj.getElementById('spacer');
	var spacerW = getWidth(spacer);
	var textbox = parent.winobj.getElementById('gismeteo_search');
	var minW = 36;
	var isResize = false;
	
	var xDiff = (this.lastWndW-document.width<0)?1:-1;
	xDiff = (this.lastWndW-document.width==0)?2:xDiff;
	
	if (xDiff == 1) {
		while(spacerW > 0) {
			isResize = false;
				for (var i = 0; i<this.cities.length; i++) {
					var cityel = parent.winobj.getElementById('strCity'+i);
					if (getWidth(cityel) < getMaxW('strCity'+i, this)) {
						setWidth(cityel, xDiff);
						isResize = true;
					}			
				}
			spacerW = getWidth(spacer);				
			if (!isResize) break;	
		} 
	}
	
	if (xDiff == -1 || xDiff == 2) {
		while (spacerW == 0) {
			isResize = false;
			if (!isResize)						
				for (var i = 0; i<this.cities.length; i++) {
					var cityel = parent.winobj.getElementById('strCity'+i);
					if (getWidth(cityel) > minW) {
						setWidth(cityel, -1);
						isResize = true;
					}
				}
			spacerW = getWidth(spacer);
			if (!isResize) break;							
		}	
	}	

	this.lastWndW = document.width;
	
	for (var i = 0; i<this.cities.length; i++) {
		var cityel = parent.winobj.getElementById('strCity'+i);
		width = getWidth(cityel);	
	}
	
	function getWidth(obj) {
		var width = document.defaultView.getComputedStyle(obj, null).getPropertyValue('width');	
		return width.replace('px', '');
	}
	
	function getMaxW(value, localThis) {
		var minW = 36;
		if (localThis.getStorage(value+'.width')) {
			if (localThis.getStorage(value+'.width') != 'null')
				return parseInt(localThis.getStorage(value+'.width'), 10);		
			else return minW;
		}
		else return minW;	
	}
	
	function setWidth(obj, step) {
		var width = getWidth(obj);
		width = parseInt(width, 10)+parseInt(step, 10);
		obj.style.width = width+"px"; 						
	}	
}

GISBar.GISClass.prototype.redraw = function(i) {
	var cityObj = this.cities[i];
	var cityName = unescape(cityObj.name);	
	var strTod = '';
	if(this.getStorage("GismeteoIconsOnPanel") == 'forecast') { 
		cityObj = cityObj.forecasts[0];
		if (cityObj == undefined) return;
		strTod = this.dict.tods[cityObj.tod].toLowerCase()+' ';	
	}
	else cityObj = cityObj.fact[0];
	if (cityObj == undefined) return;		
	var tooltiptext = cityName+': '+strTod+this.addPlus(this.getTemper(cityObj.t))+' '+this.getConditions(cityObj);
	var icon = 'chrome://gismeteobar/skin/icons/'+this.getPict(cityObj, 'mini', 'icontype1');	
	if ( i==0 && !this.getStorage("cid") || this.getStorage("cid") == i || i==0 && this.getStorage("cid")>=this.cities.length)
		this.setToolbarButton(cityObj.t, icon, tooltiptext);						
	this.setAttr('toolbaritem'+i, 'tooltiptext', tooltiptext); 
	this.setAttr('phenomena'+i, 'style', 'list-style-image: url("'+icon+'");');		
	this.setAttr('bartemper'+i, 'value', this.addPlus(this.getTemper(cityObj.t)));   						
}

GISBar.GISClass.prototype.reloadToolbarIcon = function () {
	var btn = this.winobj.getElementById('Gismeteo-button');
	if (btn) {
		document.getAnonymousNodes(btn)[1].style.visibility = 'hidden';
		document.getAnonymousNodes(btn)[0].setAttribute('style', 'list-style-image: url("chrome://gismeteobar/skin/icon-toolbutton.png");');	
		this.setAttr('Gismeteo-button', 'tooltiptext', 'Gismeteo');
	}		
}

GISBar.GISClass.prototype.setToolbarButton = function(t, icon , tooltiptext) {
	this.reloadToolbarIcon();
	var btn = this.winobj.getElementById('Gismeteo-button');
	var img_src = icon.replace(/^url\(icon\)$/, "$1");
	var display_text = this.addPlus(this.getTemper(t));
	if (btn) {
		var canvas = document.getElementById("gismeteo_button_canvas");
		canvas.setAttribute("width", 22);
    canvas.setAttribute("height", 22);
		var ctx = canvas.getContext("2d");
		var img = new Image();
		img.onload = function() {
        ctx.textBaseline = "top";
        ctx.font = "bold 9px sans-serif";        // has to go before measureText
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(img, 0, -1, img.width, img.height);

        if (display_text != "")
        {
            var w = ctx.measureText(display_text).width;
            var h = 9;                  // 9 = font height

            var rp = ((canvas.width - 4) > w) ? 2 : 1;  // right padding = 2, or 1 if text is wider
            var x = canvas.width - w - rp;
            var y = canvas.height - h - 1;          // 1 = bottom padding

            if (t>0) ctx.fillStyle = "#fe6666";             // background color
            else ctx.fillStyle = "#4ea8ea";
            ctx.fillRect(x-rp, y, w+rp+rp, h+5);
            ctx.fillStyle = "#fff";             // text color
            ctx.fillText(display_text, x, y+1); 
        }
        btn.image = canvas.toDataURL("image/png");
    };
    img.src = img_src;
		this.setAttr('Gismeteo-button', 'tooltiptext', tooltiptext);
	}	
}

GISBar.GISClass.prototype.getPict = function(tmpCityData, path, iconsType) {
	if (!iconsType) iconsType	= this.getStorage("GismeteoIconsType");
	if (!iconsType) iconsType = "icontype1";
	
	var cl = tmpCityData.cl;
	var pt = tmpCityData.pt;
	var pr = tmpCityData.pr;
	var ts = tmpCityData.ts;
	var tod = 'n'; 
	var icon = tmpCityData.icon;
	if (icon.indexOf('sun')>-1) tod = 'd'; 
	
	if (cl=="") cl = 0;
		
	if (cl == 0) {pt = 0; pr = 0, ts = 0;}
	if ((iconsType != "icontype1") && (cl == 3)) tod = '';
	
	
	if ((iconsType == "icontype1") || (pt == 0)) pr = 0;
	if (pt == 0) pt = '';
	if (pr == 0) pr = '';	
	if (ts	== 0) ts = '';
	
	if ((iconsType == 'icontype1') && (ts==1)) pt = 1;
	
	if (iconsType != 'icontype1') path = path.replace('clip_art', 'photorealistic');
	
	var img = path+'/'+tod+cl+pt+pr+ts;
	if ((iconsType != "icontype1") && (tmpCityData.ws>5) && (pt != 0)) img+='-w';
	return img+='.png';
}

GISBar.GISClass.prototype.getStorage = function(key) {
	try { return GismeteoBar_PREF.getCharPref(key); }
	catch(err) { return null; }	
}

GISBar.GISClass.prototype.setStorage = function(key, value) {
	GismeteoBar_PREF.setCharPref(key, value); 
}

GISBar.GISClass.prototype.addPlus = function(value) {
	if (value>0) value = "+"+value;
	if (value<0) value = '\u2212'+Math.abs(value);
	if (value==0)	value = value;
	return value;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

GISBar.GISClass.prototype.textboxSearchBlur = function(searchBox, value){
  searchBox.style.color='#808080';
  if (value) searchBox.value = value;
  else searchBox.value = this.dict.opt_search_title;
	this.disabledButton('addfromsearch', true);  
}

GISBar.GISClass.prototype.disabledButton = function(id, value) {
	var el = this.winobj.getElementById(id);
	alert(el);	
	if (el) el.setAttribute('disabled', value);		
}	

GISBar.GISClass.prototype.SearchCity = function(searchBox, lang, callbackfunction){
	//this.disabledButton('addfromsearch', true);	
	this.callbackfunction = callbackfunction;
	this.removeChilds(this.searchPopup);	
	this.searchPopup.hidePopup();
	if (searchBox.value.length<2) return;
	clearTimeout(this.searchTimeout);
	
	var parent = this;
	this.searchTimeout = setTimeout (function () {
		req.open("GET", parent.host +'/inform-service/'+parent.ishash+'/cities/?startsWith='+searchBox.value+'&lang='+lang, true);
		req.send(null);		
	} ,1000); 
	
	var parent = this;
	var req = new XMLHttpRequest();
	req.onreadystatechange = function() { 
		onreadyStateChangeFrc(parent, req); 
		function onreadyStateChangeFrc(parent, req) {
			if (req.readyState == 4) {
				if (req.status == 200) {
					parent.removeChilds(parent.searchPopup);			
					if (req.responseXML) var xmlElement = req.responseXML.documentElement;
					if (xmlElement != 'undefined' && xmlElement) var items = xmlElement.getElementsByTagName('item');
					if (items != undefined && items.length>0) {
  					if (parent.searchPopup.openPopup)  
  						parent.searchPopup.openPopup(searchBox, 'after_start', 0, 0, false, true);
  					for(i=0; i<items.length; i++) {
  						if (i==5) break;
  						if (items[i].getAttribute('district_name')!=undefined) var name = items[i].getAttribute('n') +' - '+items[i].getAttribute('district_name')+' - '+items[i].getAttribute('country_name');
  						else var name = items[i].getAttribute('n') +' - '+items[i].getAttribute('country_name');
  						if (parent.callbackfunction) parent.callbackfunction(items[i].getAttribute('id'), name, i);  					}
					}
				}
			}
		}
	}
	//req.open("GET", this.host +'/inform-service/'+this.ishash+'/cities/?startsWith='+searchBox.value+'&lang='+lang, true);
	//req.send(null);
}

GISBar.GISClass.prototype.createPopupLabel = function(id, name, i) {
	var label = document.createElement('label');
	label.setAttribute('id', id);		
	label.setAttribute('class', 'popupSearchLabel');
	label.setAttribute('value', name);
	label.setAttribute('crop', 'end');							
	this.searchPopup.appendChild(label);
  if (i==0) label.setAttribute('class', 'popupSearchLabel popupSearchLabel_hover');	
	if (id) {
		label.onmouseover = function() {
			label.setAttribute('class', 'popupSearchLabel popupSearchLabel_hover');	
		}
		label.onmouseout = function() {
			label.setAttribute('class', 'popupSearchLabel');	
		}	
		
		var parent = this;
		
		label.onclick = function() { objClick(parent);
			function objClick(parent) {
				parent.searchPopup.hidePopup();
				parent.winobj.getElementById('gismeteo_search').value = name;
				parent.openUrl('http://www.gismeteo.'+parent.dict.domain+'/city/daily/'+id);					
			}
		}

	  label.onkeypress = function() { objClick(parent);
			function objClick(parent) {
				parent.searchPopup.hidePopup();
				parent.winobj.getElementById('gismeteo_search').value = name;
				parent.openUrl('http://www.gismeteo.'+parent.dict.domain+'/city/daily/'+id);					
			}
		}
	}	
}

GISBar.GISClass.prototype.KeyPress = function(event, callbackfunction) {
	this.callback = callbackfunction;
	var code = (event.charCode) ? event.charCode : event.keyCode;
	switch(code) {
    case 13: 
    this.winobj.getElementById('popupSearch').childNodes[0].setAttribute('class', 'popupSearchLabel popupSearchLabel_hover');  
    this.searchPopup.hidePopup();  
    if (this.callback) this.callback();
    break;
    case 38:
		this.setSearchPopupBackgroundItem(event, -1);
    break;
    case 40:
		this.setSearchPopupBackgroundItem(event, 1);
    break;
	}
}

GISBar.GISClass.prototype.setSearchPopupBackgroundItem = function(event, step) {	
	var els = this.winobj.getElementById('popupSearch').childNodes;
	var isLabelHover = false;
	var num = 0;
	for(var i=0; i<els.length; i++)
		if(els[i].getAttribute('class').indexOf('popupSearchLabel_hover')!=-1) {
			isLabelHover = true;
			num = i;
			break;
		}
	if (!isLabelHover)
		if (step == 1) els[0].setAttribute('class', 'popupSearchLabel popupSearchLabel_hover'); 
		else els[els.length-1].setAttribute('class', 'popupSearchLabel popupSearchLabel_hover'); 
	else {
		var el = els[num];
		el.setAttribute('class', 'popupSearchLabel');
		if (step == 1) 
			try {	els[num+1].setAttribute('class', 'popupSearchLabel popupSearchLabel_hover'); }
			catch(err) { els[0].setAttribute('class', 'popupSearchLabel popupSearchLabel_hover'); }
		else
			try { els[num-1].setAttribute('class', 'popupSearchLabel popupSearchLabel_hover'); }
			catch(err) { els[els.length-1].setAttribute('class', 'popupSearchLabel popupSearchLabel_hover'); }
	}
}

GISBar.GISClass.prototype.onKeyPress = function() {
	var els = this.winobj.getElementById('popupSearch').childNodes;
	for (var i=0; i<els.length; i++)
		if (els[i].getAttribute('class').indexOf('popupSearchLabel_hover')>-1)
			els[i].onkeypress(); 	
}

GISBar.GISClass.prototype.createFrcPanel = function(parent) {	
	this.isToolbarButtonClick = false;
	this.isFrc = true;
	this.cid =  parent.getAttribute('id').replace(/[a-zA-Z]/g, '');
	if (parent.getAttribute('id') == 'Gismeteo-button') { 
		this.cid = this.getStorage('cid')?this.getStorage('cid'):0;
		if (this.cid>=this.cities.length) this.cid = 0; 
		this.isToolbarButtonClick = true;
	}
	if ((this.frcPanel.openPopup)&&(this.frcPanel)) 	
		this.frcPanel.openPopup(parent, 'after_start', 0, 0, false, true);
}

GISBar.GISClass.prototype.showFrcPanel = function() {
	this.displayWeather('block');	
	this.setColorTheme();
	this.showPreloader('visible');
	this.visibleWeather('hidden');						
	this.setAttr('li_menu_news', 'class', 'newslink');
	this.displayNews('none');
	this.cities = this.getCitiesList();
	this.displayTownsList();
	this.displayNewsLink();
	clearTimeout(this.showFrcPanelTimeout);
	var timeout = 1000;
	if (this.cities[this.cid] != undefined && this.checkFrcData(this.cities[this.cid]) == true) {
		timeout = 10000;
		this.drawFrcPanel(this.cities[this.cid]);
	}
	var parent = this;
	this.showFrcPanelTimeout = setTimeout(function(){parent.showFrcPanel()}, timeout);												

}

GISBar.GISClass.prototype.drawFrcPanel = function(cityObj) {
	var parent = this;
	this.refresh_link.onclick = function() { 
		with(parent) {
			parent.showPreloader('visible');
			parent.visibleWeather('hidden');
			if (cityObj.lastBuildFrcData == 0) return;
			clearTimeout(showFrcPanelTimeout);
			showFrcPanelTimeout = null;	
			cityObj.lastBuildFrcData = 0;
			getFrc(cid, function(){showFrcPanel()});			
		}
	}
	this.setAttr('frcPanel', 'style', 'height: 100%;');
	this.showPreloader('hidden');
	this.visibleWeather('visible');				
	this.DisplayDateTime(cityObj);
	this.DisplayRefreshTime(cityObj.lastBuildFrcData);
	this.DisplayFactContents(cityObj);
	this.DisplayFrcContents(cityObj);
	if (this.isToolbarButtonClick) this.setStyleFrcPanel();		
}

GISBar.GISClass.prototype.hideFrcPanel = function() {
	this.visibleWeather('hidden');
	clearTimeout(this.showFrcPanelTimeout);	
	if(this.frcPanel) this.frcPanel.hidePopup();	
}

GISBar.GISClass.prototype.displayTownsList = function(){
	for (var i=0; i<5; i++) {
		var obj = this.winobj.getElementById('li_menu_city'+i);
		obj.removeAttribute('class');
		this.setAttr('li_menu_city'+i, 'style', 'display: none;');
	}	
	
	var parent = this;
	
	var cityObj = this.cities[this.cid];
	if (cityObj && this.isToolbarButtonClick == false) {
		var name = unescape(cityObj.name);
		this.innerXulHtml('menu-today-menu-a'+this.cid, name);		
		this.setAttr('li_menu_city'+this.cid, 'style', 'display: inline-block;');
		var obj = this.winobj.getElementById('menu-today-menu-a'+this.cid); 
		obj.setAttribute('class', 'islink');
		obj.onclick = function() {
			parent.openUrl('http://www.gismeteo.'+parent.dict.domain+'/city/daily/'+cityObj.id);
		}
	}
	else {
		for (var i=0; i<this.cities.length; i++) {
			this.setAttr('li_menu_city'+i, 'style', 'display: inline-block;');
			var obj = this.winobj.getElementById('menu-today-menu-a'+i); 			
			obj.removeAttribute('class');			
			var name = unescape(this.cities[i].name);
			this.innerXulHtml('menu-today-menu-a'+i, name);
			obj = this.winobj.getElementById('menu-today-menu-a'+i);				
			obj.onclick = function(event) {
				parent.isFrc = true;
				parent.cid = event.target.getAttribute('id').replace(/[a-zA-Z-]/g, '');
				parent.setStorage('cid', parent.cid);
				parent.showFrcPanel();
				parent.redraw(parent.cid);
			}			
		}
		obj = parent.winobj.getElementById('li_menu_city'+parent.cid);
		if (obj) obj.setAttribute('class', 'active');
	}
}

GISBar.GISClass.prototype.DisplayDateTime = function(tmpCityData) {	
	var lastBuildFrcData = this.cities[0].lastBuildFrcData;
	for (var i = 1; i<this.cities.length; i++)	
		if (this.cities[i].lastBuildFrcData>=lastBuildFrcData) lastBuildFrcData = this.cities[i].lastBuildFrcData;		
	var UTCTm = parseInt(this.getStorage('UTCTime')?this.getStorage('UTCTime'):0, 10)+((new Date()).getTime() - lastBuildFrcData);
	tmpCityData.clock = new Date();
  if (tmpCityData.timezone != null) tmpCityData.clock.setTime(UTCTm + tmpCityData.timezone*60000);	
	else 	tmpCityData.clock.setTime(time);
	var day = tmpCityData.clock.getDay();
	var date = tmpCityData.clock.getDate();
	var month = tmpCityData.clock.getMonth();
	var minutes = tmpCityData.clock.getMinutes();
	if (minutes.toString().length == 1) minutes = '0' + minutes;
	this.innerXulHtml('day-time', this.dict.weekdays[day]+', '+date+' '+this.dict.monthes[month]+', '+tmpCityData.clock.getHours()+':'+minutes);
}

GISBar.GISClass.prototype.DisplayFactContents = function(tmpCityData) {	
	var value;	
	var fact = tmpCityData.fact[0];	
	if(fact==undefined) return;
	
	value = this.addPlus(this.getTemper(fact.t));			
	this.innerXulHtml('today-temp-main', value);
	if (this.getStorage('GismeteoTemper') == 'F') value = '°F';
	else value = '°C';		
	this.innerXulHtml('degree', value);	
		
	value = this.addPlus(this.getTemper(fact.hi));				
	this.innerXulHtml('today-comform-param', value);
	
	this.innerXulHtml('today-comform-text', this.dict.feels);	
	
	value = this.getPressure(fact.p, true);
	this.innerXulHtml('today-props-pressure', value);

	this.innerXulHtml('today-props-humidity', fact.hum);
	this.innerXulHtml('today-props-humidity-text', this.dict.hum);		
	
	value= this.getWind(fact.ws, fact.wd);
	var el = this.winobj.getElementById('today-props-wind');
	if (el) el.style.background = 'url(chrome://gismeteobar/skin/icons/wind/icon-wind-'+this.getWindPict(fact)+'.png) no-repeat 0 50%';
	this.innerXulHtml('today-props-wind', value);
	
	value = this.getConditions(fact);
	
	obj = this.winobj.getElementById('today-image');
	obj.setAttribute('src', 'chrome://gismeteobar/skin/icons/'+this.getPict(fact, 'clip_art/fact', null));
	
	this.innerXulHtml('today-props-conditions', value);			
}

GISBar.GISClass.prototype.DisplayFrcContents = function(tmpCityData) {
	var content ='';
	var day = 0;
	var fieldsetId = null;
	var infoblockWidth = '119';
		
	this.setAttr('today', 'style', 'display: none;');
	this.setAttr('tomorrow', 'style', 'display: none;');
	for (var i=0; i<4; i++)	{		
		this.setAttr('today'+i, 'style', 'display: none;');		
		this.setAttr('tomorrow'+i, 'style', 'display: none;');	
	}			
	
	var obj = this.winobj.getElementById('forecast');
	for (var i=0; i<tmpCityData.forecasts.length; i++) {
		if (day != tmpCityData.forecasts[i].day) {
			if (tmpCityData.forecasts[i].day	== tmpCityData.clock.getDate()) {
				fieldsetId  = 'today';
				content = this.dict.datesAlias[0];	
				infoblockWidth = '118';				
			}
			else {				
				fieldsetId  = 'tomorrow';
				var daynum = new Date(tmpCityData.forecasts[i].year, tmpCityData.forecasts[i].month-1, tmpCityData.forecasts[i].day).getDay();
				var weekday = this.dict.lang == 'en'?this.dict.weekdays[daynum]:this.dict.weekdays[daynum].toLowerCase();
				if (i == tmpCityData.forecasts.length-1) content = this.dict.datesAlias[1];
				else content = this.dict.datesAlias[1]+' '+weekday+', '+parseInt(tmpCityData.forecasts[i].day, 10)+' '+this.dict.monthes[tmpCityData.forecasts[i].month-1];  
			}	
			this.setAttr(fieldsetId, 'style', 'display: block;');			
			this.innerXulHtml(fieldsetId+'-legend', content);				
			day = tmpCityData.forecasts[i].day;					
		}
		var forecastBlock = document.getElementById(fieldsetId+i);
		if ((tmpCityData.forecasts[i].tod == 3) || (i == tmpCityData.forecasts.length-1))
			forecastBlock.setAttribute('class', 'info info-sun info-last info1');
		else forecastBlock.setAttribute('class', 'info info-sun info1');

		var attr = null; 	
		for (var j=0; j<4; j++)	{	
			attr = this.getAttr('today'+j, 'style');	
			this.setAttr('today'+j, 'style', attr+' width:'+infoblockWidth+'px;');
			attr = this.getAttr('tomorrow'+j, 'style');						
			this.setAttr('tomorrow'+j, 'style', attr+' width:'+infoblockWidth+'px;');
		}	
		
		forecastBlock.removeAttribute('style');	
	  forecastBlock.setAttribute('style', this.getForecastBlockStyle(tmpCityData.forecasts[i].tod));
		forecastBlock.style.display = "block";
		
		var forecast = tmpCityData.forecasts[i];
		
		this.innerXulHtml(fieldsetId+'-daytime'+i, this.dict.tods[forecast.tod]);
		
		this.innerXulHtml('forecast-'+fieldsetId+i+'-temper-main', this.addPlus(this.getTemper(forecast.t)));	
		
		this.innerXulHtml('forecast-'+fieldsetId+i+'-comfort-main', this.addPlus(this.getTemper(forecast.hi)));
		
		this.setAttr('forecast-'+fieldsetId+i+'-temper', 'style', 'background: url(chrome://gismeteobar/skin/icons/'+this.getPict(forecast, 'clip_art', null)+') no-repeat 43px -5px');
		
		this.innerXulHtml('forecast-'+fieldsetId+i+'-conditions', this.getConditions(forecast));	
			
		this.innerXulHtml('forecast-'+fieldsetId+i+'-pressure', this.getPressure(forecast.p, false));				
		
		this.innerXulHtml('forecast-'+fieldsetId+i+'-humidity', forecast.hum);
			
		this.setAttr('forecast-'+fieldsetId+i+'-wind', 'style', 'background: url(chrome://gismeteobar/skin/icons/wind/icon-wind-'+this.getWindPict(forecast)+'.png) no-repeat 0 50%');
		this.innerXulHtml('forecast-'+fieldsetId+i+'-wind', this.getWind(forecast.ws, forecast.wd));											
	}				
}

GISBar.GISClass.prototype.setStyleFrcPanel = function() {	
	var fieldsetId = null;
	var panelHeight = 0;
	
	for(var i=0; i<4; i++) {
		this.setAttr('forecast-today'+i+'-conditions', 'style', 'height: 100%;');		
		this.setAttr('forecast-tomorrow'+i+'-conditions', 'style', 'height: 100%;');
	}	
		
	for (var i=0; i<4; i++) {
		var objHeight = document.getElementById('forecast-today'+i+'-conditions').clientHeight;
		if 	(objHeight>=panelHeight) panelHeight = objHeight;				
	}
	
	for (var i=0; i<4; i++) {
		var objHeight = document.getElementById('forecast-tomorrow'+i+'-conditions').clientHeight;
		if 	(objHeight>=panelHeight) panelHeight = objHeight;					
	}	
	
	for(var i=0; i<4; i++) {
		this.setAttr('forecast-today'+i+'-conditions', 'style', 'height: '+panelHeight+'px;');		
		this.setAttr('forecast-tomorrow'+i+'-conditions', 'style', 'height: '+panelHeight+'px;');
	}	
	
	var isFullFrc = this.getStorage('GismeteoFullFrc')?this.getStorage('GismeteoFullFrc'):'false';
	if (isFullFrc == 'false')
		for(var i=0; i<4; i++) {
			this.setAttr('forecast-today'+i, 'style', 'display: none;');
			this.setAttr('forecast-tomorrow'+i, 'style', 'display: none;');					
		}  
	else
		for(var i=0; i<4; i++) {
			this.setAttr('forecast-today'+i, 'style', 'display: block;');
			this.setAttr('forecast-tomorrow'+i, 'style', 'display: block;');					
		}					
}

GISBar.GISClass.prototype.getForecastBlockStyle = function(value) {
	if (this.getStorage('GismeteoTheme') != 'multicolor') return '';	
	var color = null;
  switch (value.toString()) {
  	case '0': color = "e2e7ec";
  	break;
  	case '1': color = "d8ecfd";
  	break;  	
  	case '2': color = "ffecc1";
  	break;  	
  	case '3': color = "efdfff"; 
  	break;  		  	  	
  }
	return 'background-color: #'+color;	
}

GISBar.GISClass.prototype.getTemper = function(value) {
	if (this.getStorage('GismeteoTemper') == 'F') value = Math.round(value*1.8+32);
	return value;
}

GISBar.GISClass.prototype.getPressure = function(value, isFact) {
	var isMm = false;
	if ((!this.getStorage('GismeteoPress')) || (this.getStorage('GismeteoPress') == 'mmHg')) isMm = true;
	if (!isMm ) value = Math.round(value/0.75);
	if (isFact) {
		if(isMm) return value+' '+this.dict.pressure;
		else return value+' '+this.dict.press_hPa; 
	}
	else return value;
}


GISBar.GISClass.prototype.getWind = function(ws, wd) {
	if (ws == 0) return this.getWdir(wd, ws);
	if ((!this.getStorage('GismeteoWind')) || (this.getStorage('GismeteoWind') == 'm')) return ws+' '+this.dict.wind+', '+this.getWdir(wd, ws);
	else return Math.round(ws*3.6)+' '+this.dict.wind2+', '+this.getWdir(wd, ws); 	
}

GISBar.GISClass.prototype.getWindPict = function(value) {
	var wind_pict = value.wd;
	if (value.ws == 0) wind_pict = 0;
	if (this.getStorage("GismeteoTheme") == 'dark') wind_pict = wind_pict+'-dark';	
	return wind_pict;
}

GISBar.GISClass.prototype.getWdir = function(wd, ws) {
	if (ws==0) return this.dict.wDirs[0];
  return this.dict.wDirs[wd].toLowerCase();
}

GISBar.GISClass.prototype.getConditions = function(tmpCityData) {
	var cl = tmpCityData.cl;
	var pt = tmpCityData.pt;
	var pr = tmpCityData.pr;
	var ts = tmpCityData.ts;
	
	if (cl=="") cl=0;
	
	if (pt == 0) pr = 0;
	var text = this.dict.phenomens[cl];
	if  (pt != 0) text+=', '+this.dict.intensity[pr]+' '+this.dict.precips[pt];
	if (ts !=0) text+=', ' + this.dict.storms[1];
	return text;
}

GISBar.GISClass.prototype.displayWeather = function(value) {
	var el = this.winobj.getElementById('today_current');
	if (el) el.style.display = value; 
	el = this.winobj.getElementById('forecast');
	if (el) el.style.display = value;
	el = this.winobj.getElementById('frc-link');
	if (el) el.style.display = value;			
}

GISBar.GISClass.prototype.visibleWeather = function(value) {	
	var el = this.winobj.getElementById('today_current');
	if (el) el.style.visibility = value;
	el = this.winobj.getElementById('forecast');
	if (el) el.style.visibility = value;		
}

GISBar.GISClass.prototype.displayNews = function(value) {
	var el = this.winobj.getElementById('news');
	if (el) el.style.display = value;
	el = this.winobj.getElementById('news-link');	
	if (el) el.style.display = value;	
}

GISBar.GISClass.prototype.visibleNews = function(value) {
	this.setAttr('news_contents', 'style', 'visibility:'+value+';');	
}

GISBar.GISClass.prototype.showPreloader = function(value) {
	this.setAttr('preloader', 'style', 'visibility:'+value+';');
	this.setPreloaderPosition();
	this.setPreloaderStyle();	
}

GISBar.GISClass.prototype.setPreloaderPosition = function() {
	var topEl = Math.round(parseInt(this.winobj.getElementById('weather-block').clientHeight, 10)/2-24)+'px;';	
	var leftEl = Math.round(parseInt(this.winobj.getElementById('weather-block').clientWidth, 10)/2-24)+'px;';
	var styleEl = this.getAttr('preloader', 'style');
	this.setAttr('preloader', 'style', styleEl+'top:'+topEl+'left:'+leftEl);
}

GISBar.GISClass.prototype.setPreloaderStyle = function() {
	var theme = this.getStorage('GismeteoTheme')?this.getStorage('GismeteoTheme'):'bright';
	var srcEl = 'chrome://gismeteobar/skin/preloader_bright.gif'; 
	if (theme == 'dark' && this.isFrc) srcEl = 'chrome://gismeteobar/skin/preloader_dark.gif';
	this.setAttr('preloader-img', 'src', srcEl);
}

GISBar.GISClass.prototype.innerXulHtml = function(id, value) {
	var el = this.winobj.getElementById(id);
	if (el) {
		this.removeChilds(el);
		var textNode = this.winobj.createTextNode(value);
		el.appendChild(textNode);
	}
}

GISBar.GISClass.prototype.getAttr = function(id, attr) {
	var el = this.winobj.getElementById(id);
	if (el) return el.getAttribute(attr)+';';
	else return '';
}

GISBar.GISClass.prototype.setAttr = function(id, attr, value) {
	var el = this.winobj.getElementById(id);
	if (el) el.setAttribute(attr, value);
}

GISBar.GISClass.prototype.removeChilds = function(obj) {
	while (obj.firstChild) {
  	obj.removeChild(obj.firstChild);
  }
}

GISBar.GISClass.prototype.setColorTheme = function() {
	var theme = this.getStorage('GismeteoTheme')?this.getStorage('GismeteoTheme'):'bright';
	var el = this.winobj.getElementById('weather-block');
	el.removeAttribute('class');	
	switch(theme) {
		case 'multicolor':
		el.setAttribute('class', 'weather-block weather-block-multicolor');
		break;				
		case 'dark':
		el.setAttribute('class', 'weather-block weather-block-dark');		
		break;
		case 'bright':
		el.setAttribute('class', 'weather-block weather-block-bright');		
		break;
	}		
}

GISBar.GISClass.prototype.openMapUrl = function() {
	this.openUrl('http://www.gismeteo.'+this.dict.domain+'/map/catalog');
}

GISBar.GISClass.prototype.openUrl = function(url) {
	this.hideFrcPanel();	
	window.content.document.location = url+'/?from=firefox';
}

GISBar.GISClass.prototype.openNewsUrl = function(url) {
	window.content.document.location = url;
	this.frcPanel.hidePopup(); 
}

GISBar.GISClass.prototype.clickFooterLink = function(el) {
	var cityObj = this.cities[this.cid];
	if (!cityObj) return;
	var cid = cityObj.id;
	var id = el.getAttribute('id');
	var url = "",
			host = 'http://www.gismeteo.'+this.dict.domain;
 	switch(id) {
 		case 'for_busy':
 		url = host+'/city/busy/'+cid;
 		break;
 		case 'on3':
 		url = host+'/city/daily/'+cid;
 		break;
 		case 'on7':
 		url = host+'/city/daily/'+cid+'/4';
 		break;
 		case 'on14':
 		url = host+'/city/weekly/'+cid;
 		break;
 		case 'news-link1':
 		url = 'http://www.gismeteo.ru/news/proisshestviya/';
 		break;
 		case 'news-link2':
 		url = 'http://www.gismeteo.ru/news/klimat/';
 		break; 
 		case 'news-link3':
 		url = 'http://www.gismeteo.ru/news/sobytiya/';
 		break;  				
 		default:
 		url = host; 
 		break;
	}
	if(this.frcPanel) this.frcPanel.hidePopup();
	this.openUrl(url);
}

GISBar.GISClass.prototype.setStaticTranslate = function() {
	this.innerXulHtml('foot_logo_text', this.dict.logo);
	this.innerXulHtml('for_busy', this.dict.links[0]);
	this.innerXulHtml('on3', this.dict.links[1]);
	this.innerXulHtml('on7', this.dict.links[2]);
	this.innerXulHtml('on14', this.dict.links[3]);
	this.setAttr('btn_news', 'label', this.dict.news);	
	//this.setAttr('btn_maps', 'label', this.dict.map);
	this.setAttr('btn_settings', 'tooltiptext',this.dict.opt_title);
	this.setAttr('btn_maps', 'tooltiptext', this.dict.map);
	//this.setAttr('gismeteo_search', 'tooltiptext', this.dict.opt_search_title);
	//this.setAttr('gismeteo_search', 'value', this.dict.opt_search_title);		
}

GISBar.GISClass.prototype.DisplayRefreshTime = function(value) {
	var difference = (new Date()).getTime()-value;	
  var diff_days = Math.floor(difference / 60000 / 60*24); 
  var diff_hours = Math.floor(difference / 60000 / 60);
  var diff_minutes = Math.floor(difference / 60000);
 	if (diff_hours > 23) this.dict.ttl_reload2+' '+diff_days+' '+this.dict.day;
 	else 
	  if (diff_minutes > 59) 
	  	value = diff_hours +' '+this.dict.hour;
	   else 
	    value= diff_minutes+' '+this.dict.minute;
  if (diff_minutes<2) value = this.dict.ttl_reload4;
  if (diff_minutes<1) value = this.dict.ttl_reload; 
	if (diff_minutes>=1) value +=' '+this.dict.ttl_reload3;
	this.innerXulHtml('refresh', value);
}

GISBar.GISClass.prototype.displayNewsLink = function() {
	var el = this.winobj.getElementById('li_menu_news');
	var isNews = this.getStorage('GismeteoNews');
	if (isNews == 'true' && this.dict.lang == 'ru' && this.isToolbarButtonClick) el.style.display = 'inline-block';
	else el.style.display = 'none';
}

GISBar.GISClass.prototype.drawNews = function() {	
	this.isFrc = false;
	clearTimeout(this.showFrcPanelTimeout);
	var parent = this;
	this.refresh_link.onclick = function() { 
		parent.setStorage('GismeteoNewsData', JSON.stringify({buildData: 0, newsData: null}));
		parent.getNews(parent.drawNews);
	}
		
	for (var i=0; i<5; i++) {
		var obj = this.winobj.getElementById('li_menu_city'+i);
		obj.removeAttribute('class');		
	}		
	this.setAttr('li_menu_news', 'class', 'newslink active');	
	this.displayWeather('none');
	this.displayNews('block');
		
	var data = this.getStorage('GismeteoNewsData')?JSON.parse(this.getStorage('GismeteoNewsData')):null;
	if (data && data.buildData) {
		if ((new Date()).getTime()-data.buildData>this.newsUpdateInterval || !data.newsData[0].title) {
			this.getNews(this.drawNews);
			return;			
		}				
		this.showPreloader('hidden');
		this.visibleNews('visible');
		var news = data.newsData;
		for(var i=0; i<news.length; i++) {
			this.setAttr('news_pict'+i, 'src', news[i].pict);
			this.innerXulHtml('news_a'+i, unescape(news[i].title));
			this.setAttr('news_a'+i, 'onclick', 'GISBar.gisclass.openNewsUrl("'+news[i].link+'")');
			this.innerXulHtml('news_text'+i, unescape(news[i].description));	
		}
		this.DisplayRefreshTime(data.buildData);
		news = null;
		data = null;
	}
	else this.getNews(this.drawNews);
}

GISBar.GISClass.prototype.getNews = function(callback) {
	this.newsCallBackFunction = callback;
	var data = this.getStorage('GismeteoNewsData')?JSON.parse(this.getStorage('GismeteoNewsData')):null;
	if (data && data.buildData) {
		if ((new Date()).getTime()-data.buildData<=this.newsUpdateInterval && data.newsData[0].title) {
			if (this.newsCallBackFunction) this.newsCallBackFunction();	
			return;
		}
	}
	
	this.visibleNews('hidden');
	this.showPreloader('visible');
		
	var parent = this;
	var req = new XMLHttpRequest();
	req.onreadystatechange = function() {
		onreadyStateChangeFrc(parent, req);
		function onreadyStateChangeFrc(parent, req) {
			if (req.readyState == 4) {
				if (req.status == 200) {
					with(parent) {
						var xmlElement = req.responseXML?req.responseXML.documentElement:null;
						if (xmlElement) var f = xmlElement.getElementsByTagName('item');
						if (f && f.length>0) {
							var news = [];
							for (var i=0; i<f.length; i++) {
								var pict = 'chrome://gismeteobar/skin/news-icon.png';
								if (f[i].getElementsByTagName('enclosure')[0] != undefined) pict = f[i].getElementsByTagName('enclosure')[0].getAttribute('url').replace('src', 'anno');
								news[i] = new GISBar.GISClassNewsData(
									f[i].getElementsByTagName('title')[0].textContent,
									f[i].getElementsByTagName('description')[0].textContent.replace(/<\/?[^>]+>/g, ''),
									pict,	
									f[i].getElementsByTagName('link')[0].textContent
								);		
							}
							setStorage('GismeteoNewsData', JSON.stringify({buildData: new Date().getTime(),newsData: news}));
							news = null;
						}	
						if (newsCallBackFunction && !isFrc) newsCallBackFunction();
					}
				}
			}
		}
	}
	req.open("GET", this.newshost, true);
	req.send(null);
}

GISBar.GISClass.prototype.getLastBuildData = function(strType) {
	if (strType=='frc') strType = 'lastBuildFrcData';
	else strType = 'lastBuildNewsData';
	var lastBuildData = this.getStorage(strType);
	return lastBuildData?lastBuildData:0;
}

function jsdump(str) {
  Components.classes['@mozilla.org/consoleservice;1']
            .getService(Components.interfaces.nsIConsoleService)
            .logStringMessage(str);
}