var GISOptions = {
	gisclass: null, 
	GISClass: function (parent) {	 
		this.MainGISBar = parent;
		this.GISBar = this.MainGISBar.gisclass;
		this.cid = null;
		this.did = null;		
		this.host = this.GISBar.host;
		this.ishash = this.GISBar.ishash;
		this.dict = this.GISBar.dict;
		this.countriesTimeout = null;
		this.countriesTimeout = null;
		this.dictrictsTimeout = null;
		this.citiesTimeout = null;
		this.winobj = null;	
		this.searchTextBox = null;
		this.citySearchId = 0;
		this.fromFocus = null;								
		this.init();
	}
}

GISOptions.GISClass.prototype.init = function() {
	this.winobj = window.document;
	this.GISBar.winobj = this.GISBar.getGlobalObj();
	this.setLangMenu();
	this.setThemes();
	this.setFullFrc();
	this.setIconsType();
	this.setIconsOnPanel();			
	this.setTemperType(); // C,F
	this.setWindType(); // м/с, узлы	
	this.setPressType(); // мм, гПа;		
	this.setNews(); // новости смотрим или нет		
	this.setReloadFrc(); // таймаут	
	this.searchTextBox = this.winobj.getElementById('searchTextBox');
	this.searchTextBox.placeholder = this.dict.opt_search_title;
	//document.getAnonymousNodes(this.searchTextBox)[0].setDefaultValue(this.dict.opt_search_title);		
	this.setStaticTranslate();
	this.loadCountriesList();
	this.fillSelectCity();
}

GISOptions.GISClass.prototype.redraw = function(obj, lang) {
	this.clearSelectionListBox('selectCity');
	if(obj.disabled) return;
	var el = this.winobj.getElementById('menu');
	for(var i=0; i<el.childNodes.length; i++)
		el.childNodes[i].setAttribute('class', 'lang');		
	obj.setAttribute('class', 'lang active');
	this.dict = dict[lang];
	this.setNews();
	document.getAnonymousNodes(this.searchTextBox)[0].setDefaultValue(this.dict.opt_search_title);
	this.setStaticTranslate();
	this.setReloadFrc();
	this.clearList('district');
	this.clearList('city');
	this.loadCountriesList();
	this.translateList();
	this.disabledButtons(true);
}
	
GISOptions.GISClass.prototype.setLangMenu = function() {
	this.dict = this.GISBar.dict;
	var el = document.getElementById(this.dict.lang);
	if (el) el.setAttribute('class', 'lang active');
}

GISOptions.GISClass.prototype.setThemes = function() {
	var value = this.GISBar.getStorage('GismeteoTheme')?this.GISBar.getStorage('GismeteoTheme'):'bright';
	this.setRadioButton('themes', value);
}

GISOptions.GISClass.prototype.setIconsOnPanel = function() {
	var value	= this.GISBar.getStorage("GismeteoIconsOnPanel")?this.GISBar.getStorage("GismeteoIconsOnPanel"):'fact';
	this.setRadioButton('weather_type', value);
}

GISOptions.GISClass.prototype.setIconsType = function() {
	var value	= this.GISBar.getStorage("GismeteoIconsType")?this.GISBar.getStorage("GismeteoIconsType"):'icontype1';
	this.setRadioButton('icon_type', value);
}	
				
GISOptions.GISClass.prototype.setTemperType = function() {
	var value = this.GISBar.getStorage("GismeteoTemper")?this.GISBar.getStorage("GismeteoTemper"):'C';
	this.setRadioButton('temper', value);
}	
GISOptions.GISClass.prototype.setWindType = function() {
	var value = this.GISBar.getStorage("GismeteoWind")?this.GISBar.getStorage("GismeteoWind"):'m';
	this.setRadioButton('wind', value);
}	
GISOptions.GISClass.prototype.setPressType = function() {
	var value = this.GISBar.getStorage("GismeteoPress")?this.GISBar.getStorage("GismeteoPress"):'mmHg';
	this.setRadioButton('pressure', value);
}	
	
GISOptions.GISClass.prototype.setNews= function() {
	var value = this.GISBar.getStorage("GismeteoNews")?this.GISBar.getStorage("GismeteoNews"):'false';
	if (this.dict.lang == 'ru') {
		this.winobj.getElementById('news').setAttribute('checked', value);
		this.winobj.getElementById('news').setAttribute('disabled', false);		
	}
	else {
		this.winobj.getElementById('news').setAttribute('checked', false);
		this.winobj.getElementById('news').setAttribute('disabled', true);		
	}
}

GISOptions.GISClass.prototype.setFullFrc = function() {
	var value = this.GISBar.getStorage("GismeteoFullFrc")?this.GISBar.getStorage("GismeteoFullFrc"):'false';
	this.winobj.getElementById('fullfrc').setAttribute('checked', value);
}

GISOptions.GISClass.prototype.setRadioButton = function(objId, checkValue) {
	var el = this.winobj.getElementById(objId);
	if (el)
		for (var i=0; i<el.itemCount; i++) {
			el.getItemAtIndex(i).removeAttribute('selected');		
			if (el.getItemAtIndex(i).value == checkValue) { 
				el.getItemAtIndex(i).setAttribute('selected', 'true');
				el.getItemAtIndex(i).click();
			}
		}
}

GISOptions.GISClass.prototype.setReloadFrc = function() {
	var selIndex = 0;	
	var arr = ['15', '30', '60', '180', '360', '720', '1440'];
	var timeout = this.GISBar.getStorage("GismeteoTimeOut");
	if (!timeout) timeout = 60000*60; 
	this.clearList('refresh');	
	var el = this.winobj.getElementById('refresh'); 
	for (var i=0; i<this.dict.reloads_time_title.length; i++)
		try {
    	el.insertItemAt(i, this.dict.reloads_time_title[i], arr[i]*60000);			
			if (timeout == arr[i]*60000) selIndex = i;		
		}
		catch(err) { return; }
	el.setAttribute('disabled', false);		
	el.selectedIndex = selIndex;	
}	

GISOptions.GISClass.prototype.loadCountriesList = function() {
	this.clearList('country');
	if (!this.cid) this.cid = this.dict.default_country_id;	
	//var data = this.GISBar.readFile('countries'+this.dict.lang+'.xml');
	//if (data) this.fillSelector(data, 'country');
	//else 
	this.loadList(this.host+"/inform-service/"+this.ishash+"/countries/?lang="+this.dict.lang, "country", this.countriesTimeout);
}

GISOptions.GISClass.prototype.loadDistrictList = function() {
	this.clearList('district');
	this.clearList('city');	
	if (!this.cid) this.cid = this.dict.default_country_id;
	//var data = this.GISBar.readFile('district'+this.cid+this.dict.lang+'.xml');
	//if (data) this.fillSelector(data, 'district');	
	//else 
	this.loadList(this.host+"/inform-service/"+this.ishash+"/districts/?country="+this.cid+"&lang="+this.dict.lang, "district", this.dictrictsTimeout);	
}

GISOptions.GISClass.prototype.loadCityList = function() {
	this.clearList('city');
	if (!this.did) this.loadList(this.host+"/inform-service/"+this.ishash+"/cities/?country="+this.cid+"&lang="+this.dict.lang, "city", this.citiesTimeout);	
	else this.loadList(this.host+"/inform-service/"+this.ishash+"/cities/?district="+this.did+"&lang="+this.dict.lang, "city", this.citiesTimeout); 
}	

GISOptions.GISClass.prototype.clearList = function(id) {
	var obj = this.winobj.getElementById(id);
	obj.setAttribute('disabled', true);
	obj.removeAllItems();
	if (id == 'country') obj.insertItemAt(0, this.dict.allCountry, 0);
	if ((id == 'district') || (id == 'city')) {
		this.winobj.getElementById('addfromselect').setAttribute('disabled', true);
		//obj.insertItemAt(0, '...', 0);
	}
}

GISOptions.GISClass.prototype.loadList = function(url, objId, timeOut) {	
	clearInterval(timeOut); 
	var fn = {url: url, objId: objId, timeOut: timeOut };	
	var parent = this;
	var req = new XMLHttpRequest();
	req.onreadystatechange = function() { 
		onreadyStateChangeFrc(parent, req, fn); 
		function onreadyStateChangeFrc(parent, req, fn) {
			if (req.readyState == 4) {
				if (req.status == 200) {
					if (req.responseXML) var xmlElement = req.responseXML.documentElement;
					if (xmlElement) parent.fillSelector(xmlElement, fn.objId);				
				}
				else {
					clearTimeout(fn.timeOut);
					fn.timeOut = setTimeout(function(){ parent.loadList(fn.url, fn.objId, fn.timeOut) }, 10000); 	
				}
			}
		}	
	}	
	req.open("GET", fn.url, true);
	req.send(null);			
}

GISOptions.GISClass.prototype.fillSelector = function(xmlElement, objId) {
	var selIndex = 0;
  if (xmlElement!=null) {
  	var el = this.winobj.getElementById(objId);	  	
  	if (objId == 'city') el.removeAllItems(); 		
  	var items = xmlElement.getElementsByTagName("item");
    for(var i=0; i<items.length; i++) 
    	el.insertItemAt(i+1, items[i].getAttribute("n"), items[i].getAttribute("id"));
		if ((objId == "district") && (items.length == 0)) this.loadCityList();
		if (items.length>0) el.setAttribute('disabled', false);
		el.selectedIndex = 0;		
		if (objId == 'city') {
			el.selectedIndex = 0;
			this.winobj.getElementById('addfromselect').setAttribute('disabled', false);			
		}		
  }
}

GISOptions.GISClass.prototype.fillSelectCity = function() {
	var el = this.clearListBox();
  this.GISBar.cities = this.GISBar.getCitiesList();
  for (var i=0; i<this.GISBar.cities.length; i++)
  	el.insertItemAt(i, unescape(this.GISBar.cities[i].name), this.GISBar.cities[i].id);
}

GISOptions.GISClass.prototype.clearListBox = function() {
	var el = this.winobj.getElementById('selectCity');
	while (el.itemCount != 0)
		el.removeItemAt(0);	
	return el;
}

GISOptions.GISClass.prototype.translateList = function() {
	var ids = this.getCitiesId();	
	var el = this.clearListBox();	 
	var parent = this;
	var req = new XMLHttpRequest();
	req.onreadystatechange = function() { 
		onreadyStateChangeFrc(parent, req, el); 
		function onreadyStateChangeFrc(parent, req, el) {
			if (req.readyState == 4) {
				if (req.status == 200) {
					if (req.responseXML) var xmlElement = req.responseXML.documentElement;
					if (xmlElement) {
						var items = xmlElement.getElementsByTagName('item');
						for (var i=0; i<items.length; i++)
  						el.insertItemAt(i, items[i].getAttribute("n"), items[i].getAttribute("id"));
  				}
  				parent.disabledButtons(false); 
				}
			}
		}
	}
	req.open("GET", this.host+'/inform-service/'+this.ishash+'/cities/?id='+ids.join(',')+'&lang='+this.dict.lang, true);
	req.send(null);
}

GISOptions.GISClass.prototype.getCitiesId = function() {
	var el = this.winobj.getElementById('selectCity');
	var arr = [];
	for (var i=0; i<el.itemCount; i++) 
		arr.push(el.getItemAtIndex(i).getAttribute('value'));	
	return arr;	
}

GISOptions.GISClass.prototype.disabledButtons = function(value) {
	this.disabledButton('apply', value); 
	//this.disabledButton('up', value); 
	//this.disabledButton('down', value); 
	//this.disabledButton('delete', value); 
	this.disabledLink('ru', value); 
	this.disabledLink('en', value); 
	this.disabledLink('ua', value); 
	this.disabledLink('lt', value); 								
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


GISOptions.GISClass.prototype.changeCountry = function(value) {	
	if (value == -1 || value == 0) {
		this.clearList('city');		
		this.clearList('district');
		return;
	}
	this.did = null;
	this.cid = value;
	this.loadDistrictList();	
}	

GISOptions.GISClass.prototype.changeDistrict = function(value) {
	if(value == 0) return;
	this.did = value;
	this.loadCityList();
}

GISOptions.GISClass.prototype.addCity = function(el, value, label) {
	if (!value || value=='' || value==0 || typeof(value) == 'undefined' || label=='') return;
	var i=0;
	var is_City = false;
	var el = this.winobj.getElementById('selectCity');
	if (el.itemCount>4) alert(this.dict.opt_5_city);					
	else {
		for(i=0; i<el.itemCount; i++)
			if (value == el.getItemAtIndex(i).value) is_City = true;
		if (!is_City) el.insertItemAt(i+1, label, value);								
	}	
}

function jsdump(str) {
  Components.classes['@mozilla.org/consoleservice;1']
            .getService(Components.interfaces.nsIConsoleService)
            .logStringMessage(str);
}

GISOptions.GISClass.prototype.up = function(){
	var obj=this.winobj.getElementById("selectCity");
	var i = obj.selectedIndex;
 	if(i>0) {
   	e1 = obj.getItemAtIndex(i);
   	e2 = obj.getItemAtIndex(i-1);  	
   	obj.insertBefore(e1, e2); 
   	obj.selectItem(e1);
 	}
}

GISOptions.GISClass.prototype.down = function(){
	var obj=this.winobj.getElementById("selectCity");
	var i = obj.selectedIndex;
	if (i<0) return;
 	if (i<obj.itemCount) {
   	e1 = obj.getItemAtIndex(i);
   	e2 = obj.getItemAtIndex(i+1);	   	
   	obj.insertBefore(e2, e1); 
   	obj.selectItem(e2);   		
 	}
}

GISOptions.GISClass.prototype.delete = function() {
	var obj = this.winobj.getElementById("selectCity");
	if (obj.itemCount==1)
		alert(this.dict.opt_null_list);		
	else { 
		obj.removeItemAt(obj.selectedIndex);
   	obj.selectItem(obj.getItemAtIndex(0)); 		
	}
}

GISOptions.GISClass.prototype.applyOptions = function() { 
	if (this.isDisabledButton('apply')=='true') return;
	var cities = [];
	var cities_old = this.GISBar.getCitiesList();
	var sel = this.winobj.getElementById("selectCity");	
	for(var i=0; i<sel.itemCount; i++) 
		for(var j=0; j<cities_old.length; j++) {	
			if (sel.getItemAtIndex(i).value == cities_old[j].id) {
				cities_old[j].name = escape(sel.getItemAtIndex(i).label);
				cities.push(cities_old[j]);
				break;
			}	
			if (j == cities_old.length-1) cities.push(new this.MainGISBar.GISClassCityData(sel.getItemAtIndex(i).value, escape(sel.getItemAtIndex(i).label)));
	 
		}	
	for(var i=0; i<cities.length; i++)
		if (this.GISBar.getStorage('strCity'+i+'.width'))	
			this.GISBar.setStorage('strCity'+i+'.width', this.GISBar.getStorage('strCity'+i+'.width'));						
	this.GISBar.setCitiesList(cities);
	this.GISBar.setStorage('GismeteoLang', this.dict.lang);
	this.GISBar.setStorage('GismeteoTheme', this.winobj.getElementById('themes').value);
	this.GISBar.setStorage('GismeteoIconsType', this.winobj.getElementById('icon_type').value);	
	this.GISBar.setStorage('GismeteoIconsOnPanel', this.winobj.getElementById('weather_type').value);
	this.GISBar.setStorage('GismeteoTemper', this.winobj.getElementById('temper').value);
	this.GISBar.setStorage('GismeteoWind', this.winobj.getElementById('wind').value);
	this.GISBar.setStorage('GismeteoPress', this.winobj.getElementById('pressure').value);
	this.GISBar.setStorage('GismeteoNews', this.winobj.getElementById('news').checked);
	this.GISBar.setStorage('GismeteoFullFrc', this.winobj.getElementById('fullfrc').checked);
	this.GISBar.setStorage('GismeteoTimeOut', this.winobj.getElementById('refresh').value);										
	window.close();	
	this.GISBar.init();	
}

GISOptions.GISClass.prototype.createPopupLabel = function(id, text, i) {
	var label = this.winobj.createElement('label');
	label.setAttribute('crop', 'end');
	label.setAttribute('class', 'popupSearchLabel');
	label.setAttribute('value', text);						
	this.searchPopup.appendChild(label);
  if (i==0) label.setAttribute('class', 'popupSearchLabel popupSearchLabel_hover');		
	if (id) {
		label.onmouseover = function() {
			label.setAttribute('class', 'popupSearchLabel popupSearchLabel_hover');	
		}
		label.onmouseout = function() {
			label.setAttribute('class', 'popupSearchLabel');	
		}	
		
		var parent = GISOptions.gisclass;			
		label.onclick = function() { 
	  	parent.selectPopupLabel(id, label.value.split(' - ')[0]);					
	  };
	  label.onkeypress = function() {
	  	parent.selectPopupLabel(id, label.value.split(' - ')[0]);
	  };	  	  
	}	
}

GISOptions.GISClass.prototype.selectPopupLabel = function(id, name) {
	this.winobj.getElementById('searchTextBox').value = name;	
	this.citySearchId = id;
	this.disabledButton('addfromsearch', false);	
	this.GISBar.searchPopup.hidePopup();
}

GISOptions.GISClass.prototype.onKeyPress = function() {
	this.citySearchId = 0;	
	var els = this.winobj.getElementById('popupSearch').childNodes;
	for (var i=0; i<els.length; i++)
		if (els[i].getAttribute('class').indexOf('popupSearchLabel_hover')>-1)
			els[i].onkeypress(); 
}

GISOptions.GISClass.prototype.setStaticTranslate = function() {
	this.winobj.getElementById('logo_label').value = this.dict.title;
	this.setPosition('logo_label');
	this.winobj.getElementById('appearance').setAttribute('label', this.dict.opt_legend[0]);
	this.winobj.getElementById('icons').setAttribute('label', this.dict.opt_legend[1]);
	this.winobj.getElementById('weathertype').setAttribute('label', this.dict.opt_legend[2]);
	this.winobj.getElementById('units').setAttribute('label', this.dict.opt_legend[3]);
	this.winobj.getElementById('additionally').setAttribute('label', this.dict.opt_legend[4]);
	this.winobj.getElementById('updating').setAttribute('label', this.dict.opt_legend[5]);
	this.winobj.getElementById('location').setAttribute('label', this.dict.opt_legend[6]);	
	
	this.winobj.getElementById('bright').setAttribute('label', this.dict.opt_input[0]);	
	this.winobj.getElementById('dark').setAttribute('label', this.dict.opt_input[1]);	
	this.winobj.getElementById('multicolor').setAttribute('label', this.dict.opt_input[2]);		
	
	this.winobj.getElementById('clip-art').setAttribute('label', this.dict.opt_input[3]);	
	this.winobj.getElementById('photorealistic').setAttribute('label', this.dict.opt_input[4]);	
	
	this.winobj.getElementById('current').setAttribute('label', this.dict.opt_input[5]);	
	this.winobj.getElementById('forecast').setAttribute('label', this.dict.opt_input[6]);
	
	this.winobj.getElementById('m-c').setAttribute('label', this.dict.opt_input[9]);	
	this.winobj.getElementById('km-h').setAttribute('label', this.dict.opt_input[10]);
	
	this.winobj.getElementById('mm').setAttribute('label', this.dict.opt_input[11]);	
	this.winobj.getElementById('hpa').setAttribute('label', this.dict.opt_input[12]);	
	
	this.winobj.getElementById('news').setAttribute('label', this.dict.opt_input[13]);	
	this.winobj.getElementById('fullfrc').setAttribute('label', this.dict.opt_input[14]);	
	
	this.winobj.getElementById('addfromsearch').setAttribute('label', this.dict.opt_btn[0]);		
	this.winobj.getElementById('addfromselect').setAttribute('label', this.dict.opt_btn[0]);	
	this.winobj.getElementById('up').setAttribute('label', this.dict.opt_btn[1]);	
	this.winobj.getElementById('down').setAttribute('label', this.dict.opt_btn[2]);	
	this.winobj.getElementById('delete').setAttribute('label', this.dict.opt_btn[3]);	
	
	this.winobj.getElementById('apply').setAttribute('label', this.dict.opt_btn[4]);																															
}

GISOptions.GISClass.prototype.disabledButton = function(id, value) {
	var el = this.winobj.getElementById(id);	
	if (el) el.setAttribute('disabled', value);		
}	

GISOptions.GISClass.prototype.isDisabledButton = function(id) {
	var el = this.winobj.getElementById(id);	
	if (el) return el.getAttribute('disabled');	
	else return false; 	
}	

GISOptions.GISClass.prototype.disabledLink = function(id, value) {
	this.disabledButton(id, value);
	var el = this.winobj.getElementById(id);	
	if (el) {
		var name = el.getAttribute('class');
		if (value) el.setAttribute('class', name+' disabled');
		else el.setAttribute('class', name.replace('disabled',''));
	}
}

GISOptions.GISClass.prototype.textboxSearchFocus = function(searchBox) {
	//if (document.getAnonymousNodes(searchBox)) document.getAnonymousNodes(searchBox)[0].clearTextInput();	
	this.disabledButton('addfromsearch', true);
	//this.winobj.getElementById('selectCity').selectedIndex = -1;
}

GISOptions.GISClass.prototype.textboxSearchBlur = function(searchBox){
	if (document.getAnonymousNodes(searchBox)) {
		if (searchBox.value == '') {
	  	searchBox.style.color='#808080';
	  	document.getAnonymousNodes(searchBox)[0].showButtons()
			document.getAnonymousNodes(searchBox)[0].setDefaultValue(this.dict.opt_search_title);
			this.disabledButton('addfromsearch', true);
		}
	}  
}

GISOptions.GISClass.prototype.setPosition = function(id) {
	switch (this.dict.lang) {
		case 'ru':
		value = 105;			
		break;
		case 'ua':
		value = 112;			
		break;
		case 'lt':
		value = 128;			
		break;
		case 'en':
		value = 115;			
		break;
		default:
		value = 105;		
	}
	var el = this.winobj.getElementById(id);
	el.style.marginLeft = value+"px";
}

GISOptions.GISClass.prototype.clearSelectionListBox = function(id) {
	var obj = this.winobj.getElementById(id);
	if (obj) obj.clearSelection();
	this.disabledMoveListButtons(true);
}

GISOptions.GISClass.prototype.disabledMoveListButtons = function(value) {
	this.disabledButton('up', value); 
	this.disabledButton('down', value); 
	this.disabledButton('delete', value); 								
}