var langs = new Array("ru", "en", "ua", "lt");
var menus = new Array('Русский', 'English', 'Українською', 'Lietuvos');
var dict = {
	ru: {
		lang: "ru",
		domain: "ru",
	 	default_city_id: 4368,	
		default_city_name: "Москва",
		default_country_id: "156",
		default_country_name: "Россия",	
		datesAlias: new Array('Сегодня', 'Завтра'),
		tods: new Array("Ночью", "Утром", "Днём", "Вечером"),	
		monthes: new Array("янвaря", "февраля", "марта", "апреля", "мая", "июня", "июля", "августа", "сентября", "октября", "ноября", "декабря"),
		weekdays: new Array('Воскресенье','Понедельник','Вторник','Среда','Четверг','Пятница','Суббота'),
		wDirs: new Array("Штиль", "сев.", "св", "вост.", "юв", "южн.", "юз", "зап.", "сз"),
		phenomens: new Array('Ясно','Малооблачно','Облачно','Пасмурно'),
		intensity: new Array('', 'небольшой', '', 'сильный'),
		precips: new Array('', 'дождь', 'снег'),
		storms: new Array('', 'гроза'),
		pressure: 'мм рт. ст.',
		press_hPa: 'гПа',	
		wind: 'м/с',
		wind2: 'км/ч',
		hum: 'влажность',		
		ttl_reload: 'только что', ttl_reload2: 'более', ttl_reload3: 'назад',	ttl_reload4: 'минуту',
		minute: 'мин',
		hour: 'час',
		day: 'ден',
		feels: 'по ощущению',		
		links: new Array("для занятых", "на 3 дня", "7 дней", "2 недели"),
		link_news: new Array('Происшествия', 'Климат', 'События', ''),
		opt_title: 'Настройка расширения браузера',	
		opt_legend: new Array('Внешний вид', 'Иконки', 'Кнопка на панели браузера', 'Единицы измерения', 'Дополнительно', 'Обновление', 'Местоположения'),
		opt_input: new Array('светлый', 'тёмный', 'разноцветный', 'клип-арт', 'фотореалистичные', 'текущая погода', 'прогноз на ближайшее время', '&deg;C', '&deg;F', 'м/с', 'км/ч', 'мм рт. ст.', 'гПа', 'новости', 'подробный прогноз'),
		reloads_time_title: new Array('15 минут', '30 минут', '1 час (рекомендуется)', '3 часа', '6 часов', '12 часов', '1 день'),
		opt_btn: new Array('Добавить', 'Вверх', 'Вниз', 'Удалить', 'Применить', 'Закрыть'),
		opt_search_title: 'быстрый поиск',
		opt_no_city: 'Нет такого города в списке',
		opt_5_city: 'Не более 5 городов',
		opt_null_list: 'Список не может быть пустым',
		opt_null_search: 'По вашему запросу', opt_null_search2: 'ничего не найдено',
		title: 'Расширения',
		logo: 'прогноз погоды',
		allCountry: 'Все страны', 
		map: 'Карты',
		news: 'Новости'		 	 			
	},
	ua: {
	 	lang: "ua",
	 	domain: "ua/ua",
	 	default_city_id: "4944",
		default_city_name: "Київ",
		default_country_id: "198",
		default_country_name: "Україна",
		datesAlias: new Array('Сьогодні', 'Завтра'),				
	 	monthes: new Array('січня', 'лютого', 'березня', 'квітня', 'травня', 'червня', 'липня', 'серпня', 'вересня', 'жовтня', 'листопада', 'грудня'),
	 	weekdays: new Array("Неділя", "Понеділок", "Вівторок", "Середа", "Четвер", "П'ятниця", "Суббота"),
	 	tods: new Array("Вночі", "Вранці", "Вдень", "Ввечері"),
	 	wDirs: new Array("Штиль", "пн", "пнс", "с", "пдс", "пд", "пдз", "з", "пнз"),
	 	phenomens: new Array('Ясно','Слабка хмарність','Хмарно','Сильна хмарність'),
	 	intensity: new Array('', 'невеликий', '', 'сильний'),
		precips: new Array('', 'дощ', 'сніг'),
		storms: new Array('', 'гроза'),
	 	pressure: 'мм рт. ст.',
		press_hPa: 'гПа', 	
	 	wind: 'м/с',
		wind2: 'км/год',
		hum: 'вологість',	 
		ttl_reload: 'тільки що', 	ttl_reload2: 'більше', ttl_reload3: 'тому', ttl_reload4: 'хвилину',
		minute: 'хвилина',
		hour: 'годину',
		day: 'день',	
		feels: 'по відчуттю',	
	 	links: new Array("для зайнятих","на 3 дні","7 днів","2 тижні"),
		opt_title: 'Налаштування розширення браузера',	
		opt_legend: new Array('Зовнішній вигляд', 'Іконки', 'Кнопка на панелі браузера', 'Одиниці виміру', 'Додатково', 'Оновлення', 'Місця розташування'),
		opt_input: new Array('світлий', 'темний', 'різнобарвний', 'кліп-арт', 'фотореалістичні', 'погода за вікном', 'прогноз погоди', '&deg;C', '&deg;F', 'м/с', 'км/год', 'мм рт. ст.', 'гПа', 'новини (доступно тільки російською)', 'докладний прогноз'),		 	
		reloads_time_title: new Array('15 хвилин', '30 хвилин', '1 година', '3 години', '6 годин', '12 годин', '1 день'),
		opt_btn: new Array('Додати', 'Вгору', 'Вниз', 'Видалити', 'Застосувати', 'Закрити'),
		opt_search_title: 'швидкий пошук',
		opt_no_city: 'немає такого міста у списку',
		opt_5_city: 'Не більше 5 міст',
		opt_null_list: 'Список не може бути порожнім',
		opt_null_search: 'По вашому запиту', opt_null_search2: 'нічого не знайдено',
		title: 'Pозширень',
		logo: 'прогноз погоди',
		allCountry: 'Всі країни',
		map: 'Карти',
		news: 'Новини'		 		 		
	},
	lt: {
		lang: "lt",
		domain: "lt",
	 	default_city_id: "4230",	
		default_city_name: "Vilniaus",
		default_country_id: "105",
		default_country_name: "Rusija",
		datesAlias: new Array('Šiandien', 'Rytoj'),
		monthes: new Array("sausio", "vasario", "kovo", "balandžio", "gegužės", "birželio", "liepos", "rugpjūčio", "rugsėjo", "spalio", "lapkričio", "gruodzio"),
		weekdays: new Array("Sekmadienis", "Pirmadienis", "Antradienis", "Trečiadienis", "Ketvirtadienis", "Penktadienis", "Šeštadienis"),
		tods: new Array("Naktį", "Rytas", "Diena", "Vakaras"),
		wDirs: new Array("Štilis", "Š", "ŠR", "R", "PR", "P", "PV", "V", "ŠV"),
		phenomens: new Array('Giedra','Mažas debesuotumas','Debesuota','Didelis debesuotumas'),
		intensity: new Array('', 'mažas', '', 'stiprus'),
		precips: new Array('', 'lietus', 'sniegas'),
		storms: new Array('', 'perkūnija'),
		pressure: 'mm Hg',
		press_hPa: 'hPa',	
		wind: 'm/s',
		wind2: 'km/h',
		hum: 'drėgnumas',	
		ttl_reload: 'tiesiog', ttl_reload2: 'daugiau nei prieš', ttl_reload3: '', ttl_reload4: 'minutės',
		minute: 'min',
		hour: 'h',	
		day: 'dieną',	
		feels: 'mano',		
		links: new Array("užimtas", "3 dienos", "7 dienos", "2 savaitės"),
		opt_title: 'Įsteigti naršyklės išplėtimus',	
		opt_legend: new Array('Išvaizda', 'Piktogramos', 'Mygtukas jūsų naršyklėje', 'Vienetų', 'Papildoma informacija', 'Atnaujinti', 'Vieta'),
		opt_input: new Array('šviesos', 'tamsus', 'spalvotas', 'iliustraciją', 'fotorealistinę', 'orai šiandien', 'orų prognozė', '&deg;C', '&deg;F', 'm/s', 'km/h', 'mm Hg', 'hPa', 'naujienos (prieinama tik Rusijos)', 'detali prognozė'),		
		reloads_time_title: new Array('15 minučių', '30 minučių', '1 h', '3 h', '6 h', '12 h', '1 dieną'),
		opt_btn: new Array('Pridėti', 'Į viršų', 'Pradinė', 'Ištrinti', 'Taikyti', 'Uždaryti'),
		opt_search_title: 'greita paieška',
		opt_no_city: 'nėra tokio miesto į sąrašą',
		opt_5_city: 'Ne daugiau kaip 5 miestai',
		opt_null_list: 'Sąraše negali būti tuščias',
		opt_null_search: 'Jūsų pageidavimu', opt_null_search2: 'nieko nebuvo rasta',
		title: 'Plėtinius',
		logo: 'orų prognozė',
		allCountry: 'Visos šalys',
		map: 'Atvirukai',
		news: 'Naujienos'		 	 			 										
	},
	en: {
		lang: "en",
	 	domain: "com",	
	 	default_city_id: "4368", 	
		default_city_name: "Moscow",
		default_country_id: "156",
		default_country_name: "Russia",	
		datesAlias: new Array('Today', 'Tomorrow'),	 		
		monthes: new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"),
		weekdays: new Array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"),
		tods: new Array('Night', 'Morning', 'Day', 'Evening'),
		wDirs: new Array("Calm", 'N', 'NE', 'E', 'SE', 'S', 'SW', 'W', 'NW'),
	 	phenomens: new Array('Fair','Partly cloudy','Cloudy','Mainly cloudy'),
		intensity: new Array('', 'small', '', 'heavy'),
		precips: new Array('', 'rain', 'snow'),
		storms: new Array('', 'thunder-storm'),
	 	pressure: 'mm Hg',
		press_hPa: 'hPa', 	
	 	wind: 'm/s',
		wind2: 'km/h', 
		hum: 'humidity',
		ttl_reload: 'just now', ttl_reload2: 'more than', ttl_reload3: 'ago', ttl_reload4: ' one minute',
		minute: 'min',
		hour: 'h',
		day: 'day',
		feels: 'feels',				
		links: new Array("for busy", "for 3 days", "7 days", "for 2 weeks"),
		opt_title: 'Setting up browser extensions',
		opt_legend: new Array('Appearance', 'Icons', 'Button on your browser', 'Units', 'Additionally', 'Update', 'Location'),	
		opt_input: new Array('bright', 'dark', 'multicolor', 'clip art', 'photorealistic', 'current weather', 'weather forecast', '&deg;C', '&deg;F', 'm/s', 'km/h', 'mm Hg', 'hPa', 'news (available only in Russian)', 'detailed forecast'),			
		reloads_time_title: new Array('15 minutes', '30 minutes', '1 hour', '3 hours', '6 hours', '12 hours', '1 day'),	
		opt_btn: new Array('Add', 'Up', 'Down', 'Delete', 'Apply', 'Close'),
		opt_search_title: 'quick search',
		opt_no_city: 'there is no such city in the list',
		opt_5_city: 'Sorry, only 5 cities',
		opt_null_list: 'List can not be empty',
		opt_null_search: 'On your request', opt_null_search2: 'nothing has been found',
		title: 'Extentions',
		logo: 'weather forecast',
		allCountry: 'All countries',
		map: 'Maps',
		news: 'News'		 		 														
	}
}